package yourdomain.commons.views.components
{
	import com.bit101.components.Label;
	import com.bit101.components.Panel;
	import com.bit101.components.PushButton;
	import com.bit101.components.TextArea;
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import yourdomain.commons.controllers.events.ModularConnectorEvent;
	import yourdomain.commons.models.vos.MessagesVO;

	public class MessagesView extends Sprite
	{
		private var panel:Panel;
		private var sendMessageButton:PushButton;
		private var receivedMessagesText:TextArea;
		private var sendMessagesText:TextArea;
		private var colorArray:Array =
			new Array(0xbea6ca, 0x7fab9c, 0xFFFF33, 0xFF33FF, 0xFF3333, 0x79DCF4, 0xFF3333, 0xFFCC33, 0x99CC33, 0xbe8888, 0x8997a3);

		public function MessagesView()
		{
			addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
			//addEventListener(Event.REMOVED_FROM_STAGE, onRemovedFromStage);
		}

		private function onAddedToStage(event:Event):void
		{
			addChildren();
		}

		private function addChildren():void
		{
			panel = new Panel(this, 0, 0);
			panel.height = 110;
			panel.width = 290;
			var randomColorID:Number = Math.floor(Math.random() * colorArray.length);
			panel.color = colorArray[randomColorID];

			var sendLabel:Label = new Label(this, 11, 5, "send messages:");
			var receivedLabel:Label = new Label(this, 151, 5, "received messages:");
			sendLabel.opaqueBackground = 0xffffff;
			receivedLabel.opaqueBackground = 0xffffff;

			sendMessagesText = new TextArea(this, 10, 25);
			sendMessagesText.width = 120;
			sendMessagesText.height = 55;

			receivedMessagesText = new TextArea(this, 150, 25);
			receivedMessagesText.width = 120;
			receivedMessagesText.height = 55;
			receivedMessagesText.name = "receivedMessages";

			sendMessageButton = new PushButton(this, 10, 85, "send");

			sendMessageButton.addEventListener(MouseEvent.CLICK, onSendButtonClicked);
			panel.addChild(sendLabel);
			panel.addChild(receivedLabel);
			panel.addChild(sendMessagesText);
			panel.addChild(sendMessageButton);
			panel.addChild(receivedMessagesText);
			addChild(panel);
		}

		private function onSendButtonClicked(event:MouseEvent):void
		{
			var messagesVO:MessagesVO = new MessagesVO();
			messagesVO.message = sendMessagesText.text;
			dispatchEvent(new ModularConnectorEvent(ModularConnectorEvent.VIEW_TO_MEDIATOR_MESSAGE, messagesVO));
		}

		public function onMessageReceived(message:String):void
		{
			receivedMessagesText.text = message;
		}
		/*protected function onRemovedFromStage(event:Event):void
		{
			removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
			removeEventListener(Event.REMOVED_FROM_STAGE, onRemovedFromStage);
			sendMessageButton.removeEventListener(MouseEvent.CLICK, onSendButtonClicked);
			removeChild(panel);
		}*/
	}
}
